#![no_std]

pub use static_pins_macros::*;

pub trait StaticPin {
    type Port;
    const PIN_NUM: u8;

    fn into_input();
    fn into_output();
    fn into_pullup_input();

    fn write(data: u8);
    fn read() -> u8;
}

#[macro_export]
macro_rules! impl_static_pins {
    ($($pin:expr), +) => {
        pub trait StaticPin {
            type Port;
            const PIN_NUM: u8;

            fn into_input();
            fn into_output();
            fn into_pullup_input();

            fn write(data: u8);
            fn read() -> u8;
        }

        $(
            impl_static_pin!($pin);
        )+
    }
}
